static scheduler(void)
{
	switch(currentTask->state)
	{
		switch Active:
			/* keep on active list */
			break;
		switch Waiting:
			/* move to waiting list, sorted by timeout period, then priority */
			break;
		switch BlockedIndefinitly:
			/* move to blocked list, sorted by priority */
			break;
	}
	
	/* iterate through top of waiting stack, elapse timeouts, if possible */
	do
	{
		listIteratorGetNext(waitingList, &waitingTask);
		if(waitingTask->timeout < currentTime)
		{
			waitingTask->state = TimedOut;
			placeTaskInActiveList(waitingTask);
		}
		else
		{
			/* we're sorted by timeout, so the rest must all be
			 * not yet ready
			 */
			break;
		}
	} while(1);
	
	/* find most eligible active task */
	currentTask = findNextActiveTask();
	
	activateTask(currentTask);
}
